#########################################################
# MAKEFILE - WITHOUT CONTINUE
#########################################################
CXX=g++
CFLAGS=-Wall -g

BUILD_DIR:=build
PRES_DIR:=$(BUILD_DIR)/pres
ASS_DIR:=$(BUILD_DIR)/assemblers
OBJ_DIR:=$(BUILD_DIR)/objs

SOURCES:=$(wildcard *.cpp)
PRES:=$(patsubst %.cpp, $(PRES_DIR)/%.ii, $(SOURCES))
ASS:=$(patsubst %.cpp, $(ASS_DIR)/%.s, $(SOURCES))
OBJS:=$(patsubst %.cpp, $(OBJ_DIR)/%.o, $(SOURCES))

all: withoutcontinue
.PRECIOUS: $(ASS)
.PRECIOUS: $(PRES)

withoutcontinue: $(OBJS)
	@echo Linking...
	@$(CXX) $(CFLAGS) $< -o $@

$(OBJ_DIR)/%.o: $(ASS_DIR)/%.s
	@echo Compiling $<
	@$(CXX) $(CFLAGS) -c $< -o $@

$(ASS_DIR)/%.s: $(PRES_DIR)/%.ii
	@echo Assemblering $<
	@$(CXX) -S $< -o $@

$(PRES_DIR)/%.ii: %.cpp | $(BUILD_DIR)
	@echo Pre-processing $<
	@$(CXX) -E $< -o $@

$(BUILD_DIR):
	@echo Creating Build Directories...
	@mkdir $(BUILD_DIR) $(PRES_DIR) $(ASS_DIR) $(OBJ_DIR)

clean:
	@echo cleaning...
	@rm -rf $(BUILD_DIR) withoutcontinue